<?php
namespace PTPay\MeoWallet\Controller\Payment;

use Magento\Framework\App\Action\Action;
use Magento\Framework\App\Action\Context;
use Magento\Framework\View\Result\PageFactory;
use PTPay\MeoWallet\Logger\MeoWalletLogger;
use PTPay\MeoWallet\Model\MeoWallet;
use Magento\Framework\App\RequestInterface;
use PTPay\MeoWallet\Model\MeoWalletCheckoutFactory;
use \Magento\Checkout\Model\Session as CheckoutSession;


/**
 * Shows the multibanco page to the user
 *
 * @package PTPay\MeoWallet\Controller\Payment
 */
class Mbway extends Action
{
    /**
     * @var PageFactory
     */
    private $pageFactory;
    /**
     * @var MeoWallet
     */
    private $meoWallet;
    /**
     * @var MeoWalletLogger
     */
    private $logger;

    /**
     * @var CheckoutSession
     */
    private $checkoutSession;
    /**
     * @param Context         $context
     * @param PageFactory     $pageFactory
     * @param MeoWallet       $meoWallet
     * @param MeoWalletLogger $logger
     */
    public function __construct(
        Context $context,
        PageFactory $pageFactory,
        MeoWallet $meoWallet,
        CheckoutSession $session,
        MeoWalletLogger $logger

    ) {
        parent::__construct($context);
        $this->pageFactory = $pageFactory;
        $this->meoWallet = $meoWallet;
        $this->logger = $logger;
        $this->checkoutSession = $session;
    }


    /**
     * Dispatch request
     *
     * @return \Magento\Framework\Controller\ResultInterface|ResponseInterface
     * @throws \Magento\Framework\Exception\NotFoundException
     */
    public function execute()
    {

        $mbway_data = [];
        $mbway_data = $this->checkoutSession->getMbWayResponse();

        $this->_view->loadLayout();
        $this->_view->renderLayout();
    }

    /**
     * @inheritDoc\\
     */
    public function createCsrfValidationException(
        RequestInterface $request
    ): ?InvalidRequestException {
        /** @var Redirect $resultRedirect */
        $resultRedirect = $this->resultRedirectFactory->create();
        $resultRedirect->setPath('*/*/edit');

        return new InvalidRequestException(
            $resultRedirect,
            [new Phrase('Invalid Form Key. Please refresh the page.')]
        );
    }

    /**
     * @inheritDoc
     */
    public function validateForCsrf(RequestInterface $request): ?bool
    {
        return true;
    }


}
