<?php

namespace PTPay\MeoWallet\SDK\Exceptions;

use PTPay\MeoWallet\SDK\ApiResponse;

/**
 * Class ApiResponseException
 * @package PTPay\MeoWallet\SDK\Exceptions
 */
class ApiResponseException extends \Exception
{
    protected $reason;
    protected $link;
    protected $tid;

    /**
     * ApiResponseException constructor.
     * @param ApiResponse $apiResponse
     */
    public function __construct($apiResponse)
    {
        $data = $apiResponse->getDataAsArray();

        $this->reason = $data['reason'];
        $this->link = $data['link'];
        $this->tid = $data['tid'];

        parent::__construct($data['message'], $data['code']);
    }

    /**
     * Get Reason for humans
     * @return mixed
     */
    public function getReason()
    {
        return $this->reason;
    }

    /**
     * Link to know more about the error
     * @return string
     */
    public function getLink()
    {
        return $this->link;
    }

    /**
     * Get error guid - always include this when contacting support
     * @return string
     */
    public function getTid()
    {
        return $this->tid;
    }

}