<?php

namespace PTPay\MeoWallet\SDK\Resources;

/**
 * Class Wallet
 * @package PTPay\MeoWallet\SDK\Resources
 * @see https://developers.wallet.pt/en/procheckout/resources.html#api_v2_wallets_methods
 */
class Wallet extends ApiResource
{

    /**
     * Wallet constructor.
     * @param \PTPay\MeoWallet\SDK\Api $api
     */
    public function __construct($api)
    {
        parent::__construct($api);
    }

    /**
     * Get the wallet allowed methods
     * @return array
     * @throws \PTPay\MeoWallet\SDK\Exceptions\ApiResponseException
     */
    public function getMethods()
    {
        $response = $this->api->call('GET', '/wallets/methods');
        return $response->getDataAsArray()['methods'];
    }
}