var meowallet = {

    /**
     * Creates a new multibanco reference and add into the table
     * @param area Area to put the loading icon
     * @param url Url to call
     * @param table Table to add the new multibanco reference
     */
    createNewMb: function(area, url, table){

        var meowallet = this;
        if ($(area)) {
            var fields = $(area).select('input', 'select', 'textarea');
            var data = Form.serializeElements(fields, true);
            url = url + (url.match(new RegExp('\\?')) ? '&isAjax=true' : '?isAjax=true');
            new Ajax.Request(url, {
                parameters: $H(data),
                loaderArea: area,
                onSuccess: function (transport) {
                    try {
                        if (transport.responseText.isJSON()) {
                            var response = transport.responseText.evalJSON();

                            // Check if there is an error instead mb data
                            if (response.error == true) {
                                meowallet.addMessage(response.message, 'error', true);
                                return;
                            }

                            var mbData = response.mbData;
                            var row = '<tr class="new-mb-reference">' +
                                '<td>' + mbData.createdAt + '</td>' +
                                '<td>' + mbData.operationId + '</td>' +
                                '<td>' + mbData.entity + '</td>' +
                                '<td>' + mbData.reference + '</td>' +
                                '<td>' + mbData.amount + '</td>' +
                                '<td>' + mbData.expires + '</td>' +
                                '<td>' + mbData.status + '</td>' +
                                '</tr>';

                            // Remove info about having references
                            jQuery('.multibanco-info').hide();

                            // remove any messages
                            meowallet.clearAllMessages();


                            // Add multibanco reference to the table
                            jQuery(table).find('tbody').prepend(row);
                            jQuery(table).find('.new-mb-reference').delay(5000).queue(function () {
                                jQuery(this).removeClass('new-mb-reference').clearQueue();
                            });


                        } else {
                            console.log(transport.responseText);
                        }
                    } catch (e) {
                        console.log(e);
                    }
                }
            });
        }
    },

    /**
     * Container of the messages
     */
    messageContainer : '.messages',

    /**
     * Add a message to the screen
     * @param msg Message text to add
     * @param type Message error
     * @param clearFirst Clear the previous messages
     */
    addMessage: function(msg, type, clearFirst) {

        var html = '<div class="message message-' + type + ' ' + type + '">' +
            '<div data-ui-id="messages-message-' + type + '">' + msg + '</div>' +
            '</div>';

        if (clearFirst == true) {
            this.clearAllMessages();
        }
        jQuery(this.messageContainer).prepend(html);
    },


    /**
     * Clear all messages
     */
    clearAllMessages: function(){
        jQuery(this.messageContainer).html('');
    }


};