/*browser:true*/
/*global define*/
define([
    "jquery",
    "Magento_Checkout/js/view/payment/default",
    "mage/url",
], function ($, Component, url) {
    "use strict";

    return Component.extend({
        defaults: {
            template: "PTPay_MeoWallet/payment/wallet",
        },

        redirectAfterPlaceOrder: false,

        /**
         * After place order callback
         */
        afterPlaceOrder: function () {
            var chosenMethod = $(".checkout-meowallet-methods")
                .find('input[name="chosen_method"]:checked')
                .val();
            if (chosenMethod == "MBWAY") {
                var phone_elem = $("#mbway_phone_number");
                if (phone_elem) {
                    window.location.replace(
                        url.build(
                            "meowallet/payment/redirect?chosenMethod=" +
                                chosenMethod +
                                "&MBPhone=" +
                                phone_elem.val()
                        )
                    );
                }
            } else {
                window.location.replace(
                    url.build(
                        "meowallet/payment/redirect?chosenMethod=" +
                            chosenMethod
                    )
                );
            }
        },
        showmbwayForm: function () {
            var phone_elem = $("#mbway_phone_number");
            phone_elem.show();
            if (phone_elem) {
                phone_elem.show();
                phone_elem.focus();
                $("#chosen_method_MBWAY").checked = true;
            }
            return true;
        },
        handleRadioButtonChange: function () {
            $("#chosen_method_MBWAY").checked = false;
            document.getElementById("mbway_phone_number").style.display =
                "none";
            return true;
        },
        mbwayPhoneNumberError: function () {
            var phone_elem = $("#mbway_phone_number");
            if (typeof window.mbwayPhoneNumberError === "function") {
                window.mbwayPhoneNumberError(this);
            } else {
                phone_elem.hide(500).show(500);
            }
        },
        validate: function () {
            var chosenMethod = $(".checkout-meowallet-methods")
                .find('input[name="chosen_method"]:checked')
                .val();

            var phone_elem = $("#mbway_phone_number");
            if (phone_elem && chosenMethod == "MBWAY") {
                var phoneval = phone_elem.val();
                if (
                    phoneval.length != 9 ||
                    !phoneval.match(/^(9[1236])[0-9]{7}$/)
                ) {
                    this.mbwayPhoneNumberError();
                    return false;
                }
                return true;
            }
            return true;
        },
    });
});
